# coding: utf-8

"""
    OpsGenie REST API

    OpsGenie OpenAPI Specification  # noqa: E501

    OpenAPI spec version: 2.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from opsgenie_swagger.models.maintenance_rule import MaintenanceRule  # noqa: F401,E501
from opsgenie_swagger.models.maintenance_time import MaintenanceTime  # noqa: F401,E501


class Maintenance(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'status': 'str',
        'rules': 'list[MaintenanceRule]',
        'time': 'MaintenanceTime',
        'description': 'str'
    }

    attribute_map = {
        'id': 'id',
        'status': 'status',
        'rules': 'rules',
        'time': 'time',
        'description': 'description'
    }

    def __init__(self, id=None, status=None, rules=None, time=None, description=None):  # noqa: E501
        """Maintenance - a model defined in Swagger"""  # noqa: E501

        self._id = None
        self._status = None
        self._rules = None
        self._time = None
        self._description = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if status is not None:
            self.status = status
        if rules is not None:
            self.rules = rules
        if time is not None:
            self.time = time
        if description is not None:
            self.description = description

    @property
    def id(self):
        """Gets the id of this Maintenance.  # noqa: E501

        Identifier of the maintenance meta data  # noqa: E501

        :return: The id of this Maintenance.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Maintenance.

        Identifier of the maintenance meta data  # noqa: E501

        :param id: The id of this Maintenance.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def status(self):
        """Gets the status of this Maintenance.  # noqa: E501

        Status of the maintenance data  # noqa: E501

        :return: The status of this Maintenance.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this Maintenance.

        Status of the maintenance data  # noqa: E501

        :param status: The status of this Maintenance.  # noqa: E501
        :type: str
        """
        allowed_values = ["cancelled", "past", "active", "planned"]  # noqa: E501
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"  # noqa: E501
                .format(status, allowed_values)
            )

        self._status = status

    @property
    def rules(self):
        """Gets the rules of this Maintenance.  # noqa: E501

        Rules of maintenance, which takes a list of rule objects and defines the maintenance rules over integrations and policies.  # noqa: E501

        :return: The rules of this Maintenance.  # noqa: E501
        :rtype: list[MaintenanceRule]
        """
        return self._rules

    @rules.setter
    def rules(self, rules):
        """Sets the rules of this Maintenance.

        Rules of maintenance, which takes a list of rule objects and defines the maintenance rules over integrations and policies.  # noqa: E501

        :param rules: The rules of this Maintenance.  # noqa: E501
        :type: list[MaintenanceRule]
        """

        self._rules = rules

    @property
    def time(self):
        """Gets the time of this Maintenance.  # noqa: E501

        Time configuration of maintenance  # noqa: E501

        :return: The time of this Maintenance.  # noqa: E501
        :rtype: MaintenanceTime
        """
        return self._time

    @time.setter
    def time(self, time):
        """Sets the time of this Maintenance.

        Time configuration of maintenance  # noqa: E501

        :param time: The time of this Maintenance.  # noqa: E501
        :type: MaintenanceTime
        """

        self._time = time

    @property
    def description(self):
        """Gets the description of this Maintenance.  # noqa: E501

        Description for maintenance data  # noqa: E501

        :return: The description of this Maintenance.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this Maintenance.

        Description for maintenance data  # noqa: E501

        :param description: The description of this Maintenance.  # noqa: E501
        :type: str
        """

        self._description = description

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Maintenance):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
